#ifndef _JOYSTICK_H
#define _JOYSTICK_H

#define DIRECTINPUT_VERSION 0x0800

#include <dinput.h>
#include <stdio.h>

class Joystick
{
public:
    Joystick();
    ~Joystick();

    bool Init(HWND hwnd);
    void Update();
    void GetPosition(double* position);

    // Effects
    void PlayBump(double x, double y);

    enum{WALL_LEFT, WALL_RIGHT, WALL_UP, WALL_DOWN};

protected:
    enum{AXIS_MIN = -1000};
    enum{AXIS_MAX = 1000};

    static LPDIRECTINPUT8 g_DirectInput;
    static LPDIRECTINPUTDEVICE8 m_Device;

    LPDIRECTINPUTEFFECT m_BumpEffect;
    DIJOYSTATE m_State;

    double pos[3];

    BOOL InitBumpEffect();
    HRESULT DoBumpEffect(double xpush, double ypush);

    static BOOL CALLBACK EnumJoysticksCallback(const DIDEVICEINSTANCE *pdidInstance, void *pContext);
    static BOOL CALLBACK EnumAxesCallback(LPCDIDEVICEOBJECTINSTANCE lpddoi, void *pvRef);
};

#endif